gi-gdk4-4.0.10: Gdk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gdk.Objects.ContentSerializer

Contents

- Exported types
- Methods
  - getCancellable
  - getGtype
  - getMimeType
  - getOutputStream
  - getPriority
  - getTaskData
  - getUserData
  - getValue
  - returnError
  - returnSuccess
  - setTaskData

Description

Serializes content for inter-application data transfers.

The `GdkContentSerializer` transforms an object that is identified by a GType into a serialized form (i.e. a byte stream) that is identified by a mime type.

GTK provides serializers and deserializers for common data types such as text, colors, images or file lists. To register your own serialization functions, use `contentRegisterSerializer`.

Also see `ContentDeserializer`.

Synopsis

- newtype ContentSerializer = ContentSerializer (ManagedPtr ContentSerializer)
- class (GObject o, IsDescendantOf ContentSerializer o) => IsContentSerializer o
- toContentSerializer :: (MonadIO m, IsContentSerializer o) => o -> m ContentSerializer
- contentSerializerGetCancellable :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m (Maybe Cancellable)
- contentSerializerGetGtype :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m GType
- contentSerializerGetMimeType :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m Text
- contentSerializerGetOutputStream :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m OutputStream
- contentSerializerGetPriority :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m Int32
- contentSerializerGetTaskData :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m (Ptr ())
- contentSerializerGetUserData :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m (Ptr ())
- contentSerializerGetValue :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m GValue
- contentSerializerReturnError :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> GError -> m ()
- contentSerializerReturnSuccess :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> m ()
- contentSerializerSetTaskData :: (HasCallStack, MonadIO m, IsContentSerializer a) => a -> Ptr () -> DestroyNotify -> m ()

# Exported types

newtype ContentSerializer Source #

Memory-managed wrapper type.

Constructors

ContentSerializer (ManagedPtr ContentSerializer) |

#### Instances

Instances details

Eq ContentSerializer Source # |
Instance details Defined in GI.Gdk.Objects.ContentSerializer Methods (==) :: ContentSerializer -> ContentSerializer -> Bool Source # (/=) :: ContentSerializer -> ContentSerializer -> Bool Source #
GObject ContentSerializer Source # |
Instance details Defined in GI.Gdk.Objects.ContentSerializer
ManagedPtrNewtype ContentSerializer Source # |
Instance details Defined in GI.Gdk.Objects.ContentSerializer Methods toManagedPtr :: ContentSerializer -> ManagedPtr ContentSerializer Source #
TypedObject ContentSerializer Source # |
Instance details Defined in GI.Gdk.Objects.ContentSerializer Methods glibType :: IO GType Source #
HasParentTypes ContentSerializer Source # |
Instance details Defined in GI.Gdk.Objects.ContentSerializer
IsGValue (Maybe ContentSerializer) Source # | Convert `ContentSerializer` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gdk.Objects.ContentSerializer Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe ContentSerializer -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe ContentSerializer) Source #
type ParentTypes ContentSerializer Source # |
Instance details Defined in GI.Gdk.Objects.ContentSerializer type ParentTypes ContentSerializer = '[Object, AsyncResult]

class (GObject o, IsDescendantOf ContentSerializer o) => IsContentSerializer o Source #

Type class for types which can be safely cast to `ContentSerializer`, for instance with `toContentSerializer`.

#### Instances

Instances details

(GObject o, IsDescendantOf ContentSerializer o) => IsContentSerializer o Source # |
Instance details Defined in GI.Gdk.Objects.ContentSerializer

toContentSerializer :: (MonadIO m, IsContentSerializer o) => o -> m ContentSerializer Source #

Cast to `ContentSerializer`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, isTagged, legacyPropagateError, notify, notifyByPspec, ref, refSink, returnError, returnSuccess, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getCancellable, getData, getGtype, getMimeType, getOutputStream, getPriority, getProperty, getQdata, getSourceObject, getTaskData, getUserData, getValue.

#### Setters

setData, setDataFull, setProperty, setTaskData.

## getCancellable

contentSerializerGetCancellable Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m (Maybe Cancellable) | Returns: the cancellable for the current operation

Gets the cancellable for the current operation.

This is the `GCancellable` that was passed to [func`contentSerializeAsync`].

## getGtype

contentSerializerGetGtype Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m GType | Returns: the `GType` for the current operation

Gets the `GType` to of the object to serialize.

## getMimeType

contentSerializerGetMimeType Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m Text | Returns: the mime type for the current operation

Gets the mime type to serialize to.

## getOutputStream

contentSerializerGetOutputStream Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m OutputStream | Returns: the output stream for the current operation

Gets the output stream for the current operation.

This is the stream that was passed to [func`contentSerializeAsync`].

## getPriority

contentSerializerGetPriority Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m Int32 | Returns: the I/O priority for the current operation

Gets the I/O priority for the current operation.

This is the priority that was passed to [func`contentSerializeAsync`].

## getTaskData

contentSerializerGetTaskData Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m (Ptr ()) | Returns: the task data for `serializer`

Gets the data that was associated with the current operation.

See `contentSerializerSetTaskData`.

## getUserData

contentSerializerGetUserData Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m (Ptr ()) | Returns: the user data for this serializer

Gets the user data that was passed when the serializer was registered.

## getValue

contentSerializerGetValue Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m GValue | Returns: the `GValue` for the current operation

Gets the `GValue` to read the object to serialize from.

## returnError

contentSerializerReturnError Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> GError | `error`: a `GError`
-> m () |

Indicate that the serialization has ended with an error.

This function consumes `error`.

## returnSuccess

contentSerializerReturnSuccess Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> m () |

Indicate that the serialization has been successfully completed.

## setTaskData

contentSerializerSetTaskData Source #

Arguments

:: (HasCallStack, MonadIO m, IsContentSerializer a) |
=> a | `serializer`: a `GdkContentSerializer`
-> Ptr () | `data`: data to associate with this operation
-> DestroyNotify | `notify`: destroy notify for `data`
-> m () |

Associate data with the current serialization operation.